build 13 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420
  1. #!/usr/bin/env bash
  2. # This script helps to build release artifacts.
  3. # arg1: profile, e.g. emqx | emqx-enterprise
  4. # arg2: artifact, e.g. rel | relup | tgz | pkg
  5. set -euo pipefail
  6. [ "${DEBUG:-0}" -eq 1 ] && set -x
  7. PROFILE_ARG="$1"
  8. ARTIFACT="$2"
  9. is_enterprise() {
  10. case "$1" in
  11. *enterprise*)
  12. echo 'yes'
  13. ;;
  14. *)
  15. echo 'no'
  16. ;;
  17. esac
  18. }
  19. PROFILE_ENV="${PROFILE:-${PROFILE_ARG}}"
  20. case "$(is_enterprise "$PROFILE_ARG"),$(is_enterprise "$PROFILE_ENV")" in
  21. 'yes,yes')
  22. true
  23. ;;
  24. 'no,no')
  25. true
  26. ;;
  27. *)
  28. echo "PROFILE env var is set to '$PROFILE_ENV', but '$0' arg1 is '$PROFILE_ARG'"
  29. exit 1
  30. ;;
  31. esac
  32. # make sure PROFILE is exported, it is needed by rebar.config.erl
  33. PROFILE=$PROFILE_ARG
  34. export PROFILE
  35. # ensure dir
  36. cd -P -- "$(dirname -- "${BASH_SOURCE[0]}")"
  37. PKG_VSN="${PKG_VSN:-$(./pkg-vsn.sh "$PROFILE")}"
  38. export PKG_VSN
  39. SYSTEM="$(./scripts/get-distro.sh)"
  40. ARCH="$(uname -m)"
  41. case "$ARCH" in
  42. x86_64)
  43. ARCH='amd64'
  44. ;;
  45. aarch64)
  46. ARCH='arm64'
  47. ;;
  48. arm*)
  49. ARCH='arm64'
  50. ;;
  51. esac
  52. export ARCH
  53. ##
  54. ## Support RPM and Debian based linux systems
  55. ##
  56. if [ "$(uname -s)" = 'Linux' ]; then
  57. case "${SYSTEM:-}" in
  58. ubuntu*|debian*|raspbian*)
  59. PKGERDIR='deb'
  60. ;;
  61. *)
  62. PKGERDIR='rpm'
  63. ;;
  64. esac
  65. fi
  66. if [ "${SYSTEM}" = 'windows' ]; then
  67. # windows does not like the find
  68. FIND="/usr/bin/find"
  69. TAR="/usr/bin/tar"
  70. export BUILD_WITHOUT_ROCKSDB="on"
  71. else
  72. FIND='find'
  73. TAR='tar'
  74. fi
  75. log() {
  76. local msg="$1"
  77. # rebar3 prints ===>, so we print ===<
  78. echo "===< $msg"
  79. }
  80. make_docs() {
  81. local libs_dir1 libs_dir2 libs_dir3 docdir
  82. libs_dir1="$("$FIND" "_build/$PROFILE/lib/" -maxdepth 2 -name ebin -type d)"
  83. if [ -d "_build/default/lib/" ]; then
  84. libs_dir2="$("$FIND" "_build/default/lib/" -maxdepth 2 -name ebin -type d)"
  85. else
  86. libs_dir2=''
  87. fi
  88. if [ -d "_build/$PROFILE/checkouts" ]; then
  89. libs_dir3="$("$FIND" "_build/$PROFILE/checkouts/" -maxdepth 2 -name ebin -type d 2>/dev/null || true)"
  90. else
  91. libs_dir3=''
  92. fi
  93. case "$(is_enterprise "$PROFILE")" in
  94. 'yes')
  95. SCHEMA_MODULE='emqx_ee_conf_schema'
  96. ;;
  97. 'no')
  98. SCHEMA_MODULE='emqx_conf_schema'
  99. ;;
  100. esac
  101. docdir="_build/docgen/$PROFILE"
  102. mkdir -p "$docdir"
  103. # shellcheck disable=SC2086
  104. erl -noshell -pa $libs_dir1 $libs_dir2 $libs_dir3 -eval \
  105. "ok = emqx_conf:dump_schema('$docdir', $SCHEMA_MODULE), \
  106. halt(0)."
  107. }
  108. assert_no_compile_time_only_deps() {
  109. :
  110. }
  111. make_rel() {
  112. local release_or_tar="${1}"
  113. ./scripts/pre-compile.sh "$PROFILE"
  114. # make_elixir_rel always create rebar.lock
  115. # delete it to make git clone + checkout work because we use shallow close for rebar deps
  116. rm -f rebar.lock
  117. # compile all beams
  118. ./rebar3 as "$PROFILE" compile
  119. # generate docs (require beam compiled), generated to etc and priv dirs
  120. make_docs
  121. # now assemble the release tar
  122. ./rebar3 as "$PROFILE" "$release_or_tar"
  123. assert_no_compile_time_only_deps
  124. }
  125. make_elixir_rel() {
  126. ./scripts/pre-compile.sh "$PROFILE"
  127. export_elixir_release_vars "$PROFILE"
  128. # for some reason, this has to be run outside "do"...
  129. mix local.rebar --if-missing --force
  130. # shellcheck disable=SC1010
  131. mix do local.hex --if-missing --force, \
  132. local.rebar rebar3 "${PWD}/rebar3" --if-missing --force, \
  133. deps.get
  134. mix release --overwrite
  135. assert_no_compile_time_only_deps
  136. }
  137. ## extract previous version .tar.gz files to _build/$PROFILE/rel/emqx before making relup
  138. make_relup() {
  139. local rel_dir="_build/$PROFILE/rel/emqx"
  140. local name_pattern
  141. name_pattern="${PROFILE}-$(./pkg-vsn.sh "$PROFILE" --vsn_matcher --long)"
  142. local releases=()
  143. mkdir -p _upgrade_base
  144. while read -r tgzfile ; do
  145. local base_vsn
  146. base_vsn="$(echo "$tgzfile" | grep -oE "[0-9]+\.[0-9]+\.[0-9]+(-(alpha|beta|rc)\.[0-9])?(-[0-9a-f]{8})?" | head -1)"
  147. ## we have to create tmp dir to untar old tgz, as `tar --skip-old-files` is not supported on all plantforms
  148. local tmp_dir
  149. tmp_dir="$(mktemp -d -t emqx.XXXXXXX)"
  150. $TAR -C "$tmp_dir" -zxf "$tgzfile"
  151. mkdir -p "${rel_dir}/releases/"
  152. cp -npr "$tmp_dir/releases"/* "${rel_dir}/releases/"
  153. ## There is for some reason a copy of the '$PROFILE.rel' file to releases dir,
  154. ## the content is duplicated to releases/5.0.0/$PROFILE.rel.
  155. ## This file seems to be useless, but yet confusing as it does not change after upgrade/downgrade
  156. ## Hence we force delete this file.
  157. rm -f "${rel_dir}/releases/${PROFILE}.rel"
  158. mkdir -p "${rel_dir}/lib/"
  159. cp -npr "$tmp_dir/lib"/* "${rel_dir}/lib/"
  160. rm -rf "$tmp_dir"
  161. releases+=( "$base_vsn" )
  162. done < <("$FIND" _upgrade_base -maxdepth 1 -name "${name_pattern}.tar.gz" -type f)
  163. if [ ${#releases[@]} -eq 0 ]; then
  164. log "No upgrade base found, relup ignored"
  165. return 0
  166. fi
  167. RELX_BASE_VERSIONS="$(IFS=, ; echo "${releases[*]}")"
  168. export RELX_BASE_VERSIONS
  169. ./rebar3 as "$PROFILE" relup --relname emqx --relvsn "${PKG_VSN}"
  170. }
  171. cp_dyn_libs() {
  172. local rel_dir="$1"
  173. local target_dir="${rel_dir}/dynlibs"
  174. if ! [ "$(uname -s)" = 'Linux' ]; then
  175. return 0;
  176. fi
  177. mkdir -p "$target_dir"
  178. while read -r so_file; do
  179. cp -L "$so_file" "$target_dir/"
  180. done < <("$FIND" "$rel_dir" -type f \( -name "*.so*" -o -name "beam.smp" \) -print0 \
  181. | xargs -0 ldd \
  182. | grep -E '(libcrypto)|(libtinfo)|(libatomic)' \
  183. | awk '{print $3}' \
  184. | sort -u)
  185. }
  186. ## Re-pack the relx assembled .tar.gz to EMQX's package naming scheme
  187. ## It assumes the .tar.gz has been built -- relies on Makefile dependency
  188. make_tgz() {
  189. local pkgpath="_packages/${PROFILE}"
  190. local src_tarball
  191. local target_name
  192. local target
  193. if [ "${IS_ELIXIR:-no}" = "yes" ]
  194. then
  195. # ensure src_tarball exists
  196. ELIXIR_MAKE_TAR=yes make_elixir_rel
  197. local relpath="_build/${PROFILE}"
  198. full_vsn="$(./pkg-vsn.sh "$PROFILE" --long --elixir)"
  199. else
  200. # build the src_tarball again to ensure relup is included
  201. # elixir does not have relup yet.
  202. make_rel tar
  203. local relpath="_build/${PROFILE}/rel/emqx"
  204. full_vsn="$(./pkg-vsn.sh "$PROFILE" --long)"
  205. fi
  206. case "$SYSTEM" in
  207. macos*)
  208. target_name="${PROFILE}-${full_vsn}.zip"
  209. ;;
  210. windows*)
  211. target_name="${PROFILE}-${full_vsn}.zip"
  212. ;;
  213. *)
  214. target_name="${PROFILE}-${full_vsn}.tar.gz"
  215. ;;
  216. esac
  217. target="${pkgpath}/${target_name}"
  218. src_tarball="${relpath}/emqx-${PKG_VSN}.tar.gz"
  219. tard="$(mktemp -d -t emqx.XXXXXXX)"
  220. mkdir -p "${tard}/emqx"
  221. mkdir -p "${pkgpath}"
  222. if [ ! -f "$src_tarball" ]; then
  223. log "ERROR: $src_tarball is not found"
  224. fi
  225. $TAR zxf "${src_tarball}" -C "${tard}/emqx"
  226. if [ -f "${tard}/emqx/releases/${PKG_VSN}/relup" ]; then
  227. ./scripts/relup-build/inject-relup.escript "${tard}/emqx/releases/${PKG_VSN}/relup"
  228. fi
  229. ## try to be portable for tar.gz packages.
  230. ## for DEB and RPM packages the dependencies are resoved by yum and apt
  231. cp_dyn_libs "${tard}/emqx"
  232. case "$SYSTEM" in
  233. macos*)
  234. # if the flag to sign macos binaries is set, but developer certificate
  235. # or certificate password is not configured, reset the flag
  236. # could happen, for example, when people submit PR from a fork, in this
  237. # case they cannot access secrets
  238. if [[ "${APPLE_SIGN_BINARIES:-0}" == 1 && \
  239. ( "${APPLE_DEVELOPER_ID_BUNDLE:-0}" == 0 || \
  240. "${APPLE_DEVELOPER_ID_BUNDLE_PASSWORD:-0}" == 0 ) ]]; then
  241. echo "Apple developer certificate is not configured, skip signing"
  242. APPLE_SIGN_BINARIES=0
  243. fi
  244. if [ "${APPLE_SIGN_BINARIES:-0}" = 1 ]; then
  245. ./scripts/macos-sign-binaries.sh "${tard}/emqx"
  246. fi
  247. ## create zip after change dir
  248. ## to avoid creating an extra level of 'emqx' dir in the .zip file
  249. pushd "${tard}/emqx" >/dev/null
  250. zip -r "../${target_name}" -- * >/dev/null
  251. popd >/dev/null
  252. mv "${tard}/${target_name}" "${target}"
  253. if [ "${APPLE_SIGN_BINARIES:-0}" = 1 ]; then
  254. # notarize the package
  255. # if fails, check what went wrong with this command:
  256. # xcrun notarytool log --apple-id <apple id> \
  257. # --apple-id <apple id> \
  258. # --password <apple id password>
  259. # --team-id <apple team id> <submission-id>
  260. echo 'Submitting the package for notarization to Apple (normally takes about a minute)'
  261. notarytool_output="$(xcrun notarytool submit \
  262. --apple-id "${APPLE_ID}" \
  263. --password "${APPLE_ID_PASSWORD}" \
  264. --team-id "${APPLE_TEAM_ID}" "${target}" \
  265. --no-progress \
  266. --wait)"
  267. echo "$notarytool_output"
  268. echo "$notarytool_output" | grep -q 'status: Accepted' || {
  269. echo 'Notarization failed';
  270. exit 1;
  271. }
  272. fi
  273. # sha256sum may not be available on macos
  274. openssl dgst -sha256 "${target}" | cut -d ' ' -f 2 > "${target}.sha256"
  275. ;;
  276. windows*)
  277. pushd "${tard}" >/dev/null
  278. 7z a "${target_name}" ./emqx/* >/dev/null
  279. popd >/dev/null
  280. mv "${tard}/${target_name}" "${target}"
  281. sha256sum "${target}" | head -c 64 > "${target}.sha256"
  282. ;;
  283. *)
  284. ## create tar after change dir
  285. ## to avoid creating an extra level of 'emqx' dir in the .tar.gz file
  286. pushd "${tard}/emqx" >/dev/null
  287. $TAR -zcf "../${target_name}" -- *
  288. popd >/dev/null
  289. mv "${tard}/${target_name}" "${target}"
  290. sha256sum "${target}" | head -c 64 > "${target}.sha256"
  291. ;;
  292. esac
  293. log "Archive successfully repacked: ${target}"
  294. log "Archive sha256sum: $(cat "${target}.sha256")"
  295. }
  296. trap docker_cleanup EXIT
  297. docker_cleanup() {
  298. rm -f ./.dockerignore >/dev/null
  299. }
  300. ## This function builds the default docker image based on debian 11
  301. make_docker() {
  302. EMQX_BUILDER="${EMQX_BUILDER:-${EMQX_DEFAULT_BUILDER}}"
  303. EMQX_RUNNER="${EMQX_RUNNER:-${EMQX_DEFAULT_RUNNER}}"
  304. EMQX_DOCKERFILE="${EMQX_DOCKERFILE:-deploy/docker/Dockerfile}"
  305. if [[ "$PROFILE" = *-elixir ]]; then
  306. PKG_VSN="$PKG_VSN-elixir"
  307. fi
  308. local default_tag="emqx/${PROFILE%%-elixir}:${PKG_VSN}"
  309. EMQX_IMAGE_TAG="${EMQX_IMAGE_TAG:-$default_tag}"
  310. echo '_build' >> ./.dockerignore
  311. set -x
  312. docker build --no-cache --pull \
  313. --build-arg BUILD_FROM="${EMQX_BUILDER}" \
  314. --build-arg RUN_FROM="${EMQX_RUNNER}" \
  315. --build-arg EMQX_NAME="$PROFILE" \
  316. --tag "${EMQX_IMAGE_TAG}" \
  317. -f "${EMQX_DOCKERFILE}" .
  318. [[ "${DEBUG:-}" -eq 1 ]] || set +x
  319. }
  320. function join {
  321. local IFS="$1"
  322. shift
  323. echo "$*"
  324. }
  325. # used to control the Elixir Mix Release output
  326. # see docstring in `mix.exs`
  327. export_elixir_release_vars() {
  328. local profile="$1"
  329. case "$profile" in
  330. emqx|emqx-enterprise)
  331. export ELIXIR_MAKE_TAR=${ELIXIR_MAKE_TAR:-no}
  332. ;;
  333. emqx-pkg|emqx-enterprise-pkg)
  334. export ELIXIR_MAKE_TAR=${ELIXIR_MAKE_TAR:-yes}
  335. ;;
  336. *)
  337. echo Invalid profile "$profile"
  338. exit 1
  339. esac
  340. export MIX_ENV="$profile"
  341. }
  342. log "building artifact=$ARTIFACT for profile=$PROFILE"
  343. case "$ARTIFACT" in
  344. doc|docs)
  345. make_docs
  346. ;;
  347. rel)
  348. make_rel release
  349. ;;
  350. relup)
  351. make_relup
  352. ;;
  353. tgz)
  354. make_tgz
  355. ;;
  356. pkg)
  357. # this only affect build artifacts, such as schema doc
  358. export EMQX_ETC_DIR='/etc/emqx/'
  359. if [ -z "${PKGERDIR:-}" ]; then
  360. log "Skipped making deb/rpm package for $SYSTEM"
  361. exit 0
  362. fi
  363. export EMQX_REL_FORM="$PKGERDIR"
  364. if [ "${IS_ELIXIR:-}" = 'yes' ]; then
  365. make_elixir_rel
  366. else
  367. make_rel tar
  368. fi
  369. env EMQX_REL="$(pwd)" \
  370. EMQX_BUILD="${PROFILE}" \
  371. make -C "deploy/packages/${PKGERDIR}" clean
  372. env EMQX_REL="$(pwd)" \
  373. EMQX_BUILD="${PROFILE}" \
  374. make -C "deploy/packages/${PKGERDIR}"
  375. ;;
  376. docker)
  377. make_docker
  378. ;;
  379. elixir)
  380. make_elixir_rel
  381. ;;
  382. *)
  383. log "Unknown artifact $ARTIFACT"
  384. exit 1
  385. ;;
  386. esac